/*

 Dex4u sample
 by 0x4e71

*/

// align section to 512 (instead of 4096)
#pragma comment (linker, "/ALIGN:512")

// merge all sections together
#pragma comment (linker, "/MERGE:.text=.dex4u")
#pragma comment (linker, "/MERGE:.rdata=.dex4u")
#pragma comment (linker, "/MERGE:.data=.dex4u")
#pragma comment (linker, "/MERGE:.rsrc=.dex4u")
#pragma comment (linker, "/MERGE:.bss=.dex4u")

// make sure we get relocations
#pragma comment (linker, "/FIXED:NO")

// section in memroy must be execute/read/writeable (irrelevant to dex4u)
#pragma comment (linker, "/SECTION:.dex4u,ERW")

// define entry point 
#pragma comment (linker, "/ENTRY:\"main\"")

// avoid default libraries
#pragma comment (linker, "/NODEFAULTLIB")


typedef unsigned int DWORD;

void dummy();
DWORD Functions;

void __fastcall PrintString(const char *s) {
	__asm {
		mov eax,[Functions]
		mov esi,[s]
		call [eax+4*9]
	};
}

void __fastcall WriteHex32(DWORD val) {
	__asm {
		mov eax,[val]
		mov ecx,[Functions]
		call [ecx+13*4]
	}
}

char WaitForKeyPress() {
	char c;
	__asm {
		mov eax,[Functions]
		call [eax+4*4]		
		mov [c],al
	}
	return c;
}

int main() {
	__asm {
        mov ax,18h            
        mov ds,ax             
        mov es,ax             
        lea edi,dummy
        add edi,512
        mov ebx,edi
        mov al,0              
        mov ah,0x0a           
        int 40h		
        mov [Functions],ebx        
	}
	PrintString("One two three four..\x0D");
	for (int i=0; i<4; i++) {
		WriteHex32(i+1); PrintString(" Hello! This is a test!\x0D");
	}
	WaitForKeyPress();
	
	return 0;	
}

void dummy(){
}
